import parport.ParallelPort;

/** Diese Klasse spielt mit den 8 Ausgabe-Bits und den 5 Eingabe-Bits
 *  des Parallelports. Es gibt nur drei wichtige Dinge, die man tun
 *  kann: write, read, warte.
 *
 * Vorher müssen einige Dateien an die richtigen Stellen kopiert werden:
 * - Userport.sys nach windows\system32\drivers\
 * - parport.dll  nach windows\system32\
 * - ParallelPort.class im Paket parport muss von javac gefunden werden,
 *   also sollte das Verzeichnis parport am besten im gleichen Verzeichnis
 *   liegen, wie die Klasse, die den Parallelport verwenden will.
 *   Die einzige Datei, die im Verzeichnis parport liegen MUSS, ist
 *   ParallelPort.class.
 *
 * Da Windows ab 2000 keinen Zugriff auf die Ports erlaubt, muss vor dem
 * Start des Javaprogramms UserPort.exe aufgerufen werden, um damit den
 * Kerneltreiber zu starten.
 */

public class TestPort{
  public static ParallelPort port=new ParallelPort(0x378);//ggf. andere Adresse!

  public static final int[] SEGMENT={0x3f, 0x06, 0x5b, 0x4f, 0x66,
    0x6d, 0x7d, 0x07, 0x7f, 0x6f, 0x77, 0x7c, 0x58, 0x5e, 0x79, 0x71};

  public static void warte(int millis){
    try{Thread.sleep(millis);}
    catch(Exception e){}
  }

  public static void siebensegment(int nybble, boolean komma){
    int leds=SEGMENT[nybble & 15];
    if(komma) leds|=0x80;
    port.write(leds);
  }

  public static void main(String[] args){
    for(int i=0; i<30; i++){
      warte(500);
      int bits=port.read(); //lies von den vier Statuspins
      System.out.println("gelesen: "+bits);
      port.write(bits); // schreibe auf die Ausgabepins
      System.out.println("ausgegeben: "+bits);
    }
    // aufsteigendes Einzellicht
    for(int i=1; i<256; i+=i){
      port.write(i);
      warte(400);
    }
    for(int i=0; i<32; i++){
      siebensegment(i, i>31);
      warte(500);
    }
  }
}
